Subject: Re: [bug-diffutils] bug#18402: bug#18402: Wrong output for single character files without newline

From: Jim Meyering <[email-masked]>
Date: Wed, 3 Sep 2014 22:12:04 -0700

On Wed, Sep 3, 2014 at 5:20 PM, Paul Eggert <[email-masked]> wrote:
> Jim Meyering wrote:
>>
>> can you give performance deltas on moderate
>> or pathologically affected inputs?
>
>
> Maybe something like this:
>
> diff --horizon-lines=100000000000000000000 gnulib/ChangeLog /tmp/ChangeLog
>
> where the two files are copies.  The bug fix sped up performance about 5x on
> my platform, which is Fedora 20 x86-64, AMD Phenom II X4 910e.

Thanks for the details.  I tried to reproduce using two copies of
gnulib/ChangeLog, but saw identical times for before/after runs.
I also tried with two copies of the output of "seq 9999999" on a
tmpfs file system, with the same result: no discernible difference.
I tried both on an AMD FX(tm)-4100 and an Intel(R) Core(TM) i7-4770S
Here are the commands I ran:

seq 9999999 > /t/1 && cp /t/2
env time src/diff --horizon-lines=100000000000000000000 /t/[12]

Then I took the best of five elapsed times and compared.
Here's the minimum time on the faster system, both with and without the patch:

$ env time src/diff --horizon-lines=100000000000000000000 /t/[12]
1.94user 0.34system 0:02.29elapsed 99%CPU (0avgtext+0avgdata
1112960maxresident)k
0inputs+0outputs (0major+404031minor)pagefaults 0swaps